
import json, time
import http.client

#TODO use MQTT instead of this class. Let CANIQUE SERVER push data to our client if needed

class ApiTemperature(object):

    def __init__(self, apiHost = 'api.canique.com', apiPath = '/weather/AT/Vienna'):
        self.apiHost = apiHost
        self.apiPath = apiPath
        self.cacheSeconds = 9*60 #9 minutes. With Python3 time.time() returns seconds
        self.lastFetchedTemperature = None
        self.fetchTs = 0

    def getTemperature(self):
        if self.fetchTs > time.time() - self.cacheSeconds:
            return self.lastFetchedTemperature


        conn = http.client.HTTPSConnection(self.apiHost, 443, timeout=3)
        conn.request("GET", self.apiPath)
        response = conn.getresponse()
        if response.status == 200:
            weatherData = json.loads(response.read())

            self.fetchTs = time.time()
            self.lastFetchedTemperature = float(weatherData['main']['temp'])

            print("Fetched current weather data.")

            return self.lastFetchedTemperature

        if self.lastFetchedTemperature != None:
            print("Warning: Could not fetch outside temp, using last valid outside temperature")
            return self.lastFetchedTemperature

        return None
